(* Modula-2 Multipass-Compiler               UNIX/MC68020 *)
(* (c) Universitaet Ulm, Sektion Informatik,   D-7900 Ulm *)
DEFINITION MODULE MCMnemonics; (* AFB 10/87 *)

   TYPE
      Mnemonic = (ABCD, ADD, ADDA, ADDI, ADDQ, ADDX, ANDop,(* ANDI,*)
		  ASL, ASR,
		  BCC, BCS, BEQ, BGE, BGT, BHI, BLE, BLS, BLT, BMI,
		  BNE, BPL, BVC, BVS,
		  BCHG, BCLR, BFCHG, BFCLR, BFEXTS, BFEXTU, BFFFO,
		  BFINS, BFSET, BFTST, BKPT, BRA, BSET, BSR, BTST,
		  CALLM, CAS, CAS2, CHK, CHK2, CLR, CMP,(* CMPA,*)
		  CMPI, CMPM, CMP2,
		  DBCC, DBCS, DBEQ, DBF, DBGE, DBGT, DBHI, DBLE,
		  DBLS, DBLT, DBMI, DBNE, DBPL, DBRA, DBT, DBVC, DBVS,
		  DIVS, DIVSL, DIVU, DIVUL, EOR, EORI, EXG, EXT, EXTB,
		  (*ILLEGAL,*) JMP, JSR, LEA, LINK, LSL, LSR, MOVE, MOVEA, MOVEC,
		  MOVEM, MOVEP, MOVEQ, MULS, MULU, NBCD, NEG, NEGX, NOP,
		  NOTop, ORop, ORI, PACK, PEA, RESET, ROL, ROR, ROXL, ROXR,
		  RTD, RTE, RTM, RTR, RTS, SBCD,
		  SCC, SCS, SEQ, SF, SGE, SGT, SHI, SLE,
		  SLS, SLT, SMI, SNE, SPL, ST, SVC, SVS,
		  SUB, SUBA, SUBI, SUBQ, SUBX, SWAP, TAS, TRAP,
		  TRAPCC, TRAPCS, TRAPEQ, TRAPF, TRAPGE, TRAPGT, TRAPHI, TRAPLE,
		  TRAPLS, TRAPLT, TRAPMI, TRAPNE, TRAPPL, TRAPT, TRAPVC, TRAPVS,
		  TRAPV, TST, UNLK, UNPK,
		  (* MC68881 floating point co-processor *)
		  FABS, FACOS, FADD, FASIN, FATAN, FATANH,
		  FBGE, FBGL, FBGLE, FBGT, FBLE, FBLT,
		  FBNGE, FBNGL, FBNGLE, FBNGT, FBNLE, FBNLT,
		  FBSEQ, FBSNE, FBSF, FBST,
		  FBOGE, FBOGL, FBOGLE, FBOGT, FBOLE, FBOLT,
		  FBUGE, FBUEQ, FBUN, FBUGT, FBULE, FBULT,
		  FBEQ, FBNE, FBF, FBT,
		  FCMP, FCOS, FCOSH,
		  FDBGE, FDBGL, FDBGLE, FDBGT, FDBLE, FDBLT,
		  FDBNGE, FDBNGL, FDBNGLE, FDBNGT, FDBNLE, FDBNLT,
		  FDBSEQ, FDBSNE, FDBSF, FDBST,
		  FDBOGE, FDBOGL, FDBOGLE, FDBOGT, FDBOLE, FDBOLT,
		  FDBUGE, FDBUEQ, FDBUN, FDBUGT, FDBULE, FDBULT,
		  FDBEQ, FDBNE, FDBF, FDBT,
		  FDIV, FETOX, FETOXM1, FGETEXP, FGETMAN,
		  FINT, FINTRZ, FLOG10, FLOG2, FLOGN, FLOGNP1,
		  FMOD, FMOVE, FMOVECR, FMOVEM, FMUL, FNEG,
		  FNOP, FREM, FSCALE,
		  FSGE, FSGL, FSGLE, FSGT, FSLE, FSLT,
		  FSNGE, FSNGL, FSNGLE, FSNGT, FSNLE, FSNLT,
		  FSSEQ, FSSNE, FSSF, FSST,
		  FSOGE, FSOGL, (*FSOGLE,*) FSOGT, FSOLE, FSOLT,
		  FSUGE, FSUEQ, FSUN, FSUGT, FSULE, FSULT,
		  FSEQ, FSNE, FSF, FST,
		  FSGLDIV, FSGLMUL, FSIN, FSINCOS,
		  FSINH, FSQRT, FSUB, FTAN, FTANH, FTENTOX,
		  FTRAPGE, FTRAPGL, FTRAPGLE, FTRAPGT, FTRAPLE, FTRAPLT,
		  FTRAPNGE, FTRAPNGL, FTRAPNGLE, FTRAPNGT, FTRAPNLE, FTRAPNLT,
		  FTRAPSEQ, FTRAPSNE, FTRAPSF, FTRAPST,
		  FTRAPOGE, FTRAPOGL, FTRAPOGLE, FTRAPOGT, FTRAPOLE, FTRAPOLT,
		  FTRAPUGE, FTRAPUEQ, FTRAPUN, FTRAPUGT, FTRAPULE, FTRAPULT,
		  FTRAPEQ, FTRAPNE, FTRAPF, FTRAPT,
		  FTST, FTWOTOX (*FYTOX*));

      MnemRange = [MIN(Mnemonic)..MAX(Mnemonic)];
      MnemString = ARRAY [0..8] OF CHAR;

   VAR
      Mnem: ARRAY MnemRange OF MnemString;

END MCMnemonics.
